#lang "qb"

#cmdline "-gen gcc -O 3 stuff.bas stuff2.bas" 
'"-exx"

REM $dynamic
defint A-Z

declare sub drawquad (e%, c%, l%)
declare sub checky (e%)
declare sub thrust_obj (o%, dis%)
declare sub update (M%)
declare function f3d% (e%, x1&, y1&, z1&, xn%, yn%)
declare sub cHECKFIELD (o%, l%, DUMMY%)
declare sub music_check ()
declare sub music_init ()
declare sub dq (e%)
declare function fd% (e%, x1&, y1&, z1&, xn%, yn%)
declare sub loadimage (c%, a$, xx%, yy%)
declare sub colorize (i%, c1%, c2%, c3%)
declare sub load_events (n%)
declare sub check_events ()
declare sub find_distance (o%, dis%, r%, rx&, rz&)
declare sub qsort (LFT%, RGHT%)
declare sub savel ()

declare sub prnt (a$, x%, y%, c%)

declare sub load_world (a$, n%)
declare function exist% (a$)

declare sub load_objects ()

declare function load_field% (a$)
declare sub play3d (n%, o%)
declare function load_object% (a$)

declare sub xmsapi ()
declare sub XMSFREE (byref fmem as long, byref tmem as long)
declare function move2xms ( byval Kb as long , byval DummySegm as integer , byval Offs as any __ptr , byval hHandle as integer , byval xmsoffs as long )
declare function movefromxms ( byval Kb as long , byval hHandle as integer , byval xmsoffs as long , byval DummySegm as integer , byval Offs as any __ptr )
'declare function movefromxms ( Kb& , hHandle% , xmsoffs& , DummySegm% , Offs  as any __ptr )
'declare function move2xms ( Kb& , DummySegm% , Offs as any __ptr , hHandle% , xmsoffs& )
declare function XmsdeAlloc (byval hHandle as integer)
declare function XmsAlloc (byval Kb as integer)
declare function XmsVersion% ()
declare function XmsRealloc (byval hHandle as integer, byval Kb as integer)

' //3d engine test

' //4-1-99
' //Eric Carr
' //Just updated for dqb v1.5
' //Fixed texture map clipping error

' //4-5-99
' //Trying to add z-buffering
' //Added loading for .3D and T3D (internal format) files
dim shared eyeyy as integer, qut as integer
' //4-10-99
' //Adding more functions
' //F1 -Help screen now active
' //Added Uncompressing in saving
' // Added Z-buffering using Quick Sort
' // Added editing windows

' //4-21-99
' //Updating editing windows


' //5-10-99
' //Added multiple textures (10 right now)

' //5-13-99
' //Added walkthrough

'//5-25-99 added Small beta game

'$INCLUDE: 'DIRECTQB.BI'
'$INCLUDE: 'common.bi'

'CONST bb = -32768
'CLEAR

'ON ERROR GOTO e

const version$ = "1.12"

' ==================///----INIT PROGRAM----\\\======================

dim shared numfdis
dim shared showf$
' *** MUSIC MODULE ***
dim shared music_file as string, music_counter as long, music_n1, music_n2
music_counter = 0: music_n1 = 1: music_n2 = 2
music_file = "intro1.snd"
' *** END MUSIC MODULE ***

if exist("ham.pal")=0 then chdir "ham3d"
if exist("ham.pal")=0 then print "couldnt find required 'ham.pal', aborting...":sleep:system
print __curdir

showf$ = "0"
'screen 0
'screen 0
'width 80, 25

cls

color 2, 1: locate 1, 1: a$ = "HAM-3d Engine startup beta v" + version$
locate 1, 1: print space$(80): locate 1, 40 - (len(a$) / 2): print a$
color 15, 0
print
print "_Init DirectQB"
if DQBinit(2, 2, 0) then print "Initialization error, program aborted": DQBclose: end
'DUMMY& = SETMEM(-66000)
e = DQBsetBaseLayer(B0)
print "_Init Mouse"
e = DQBmouseDetected
mouse = 1
if e = 0 then
  print "Mouse NOT Detected!  Use the arrow keys to turn.": mouse = 0
end if
no_sound = 1: goto skip_sound
'IF INSTR(UCASE$(COMMAND$), "/NOSOUND") THEN no_sound = 1: GOTO skip_sound
print "_Init SoundCard (SKIPPED)"
'DUMMY& = SETMEM(-17000)
dim shared g_x(6), g_y(6), count(6), cok(6), xt(6), yt(6), xt2(6), yt2(6), xt3(6), yt3(6)
'IF DQBinstallSB(1, 4, 11025, AUTO, AUTO, AUTO) THEN
'    ' Bad initialization
'DIM SHARED coount, dist
'    COLOR 12: PRINT "!!Unable to init SoundCard!!  Make sure your blaster variabe is set": COLOR 15
no_sound = 1

'    SLEEP 2
goto skip_sound
'END IF

print "_Init Sounds ["; : color 7:

'IF DQBloadSound(1, "b.wav") THEN DQBclose: PRINT DQBerror$: END ELSE PRINT ".";
'IF DQBloadSound(2, "e.wav") THEN DQBclose: PRINT DQBerror$: END ELSE PRINT ".";
color 15: print "]"

main_volume = 8
DQBsetVolume main_volume
DQBsetVoiceVol 1, 45
DQBsetVoiceVol 2, 45
skip_sound:
eyeyy = 0
dist = 500

de = 10
print "_Init Available base Memory: "; fre(-1); "bytes"
xmsapi
XMSFREE fmem&, tmem&
print "_Init Available XMS Memory:"; tmem&; "Kbytes"
if fmem& < 600 then print "at least 600k XMS should be free!": DQBclose: system
handle1 = XmsAlloc(600)

print "_Init Variables"

' ==================///----VARIABLES----\\\======================

dim shared event(30, 10) as eve
dim shared eventtop(30)
dim shared areavp(10000)
dim shared areav(30, 1)
dim shared pdata(10000)
dim shared pdatap(30, 1)
dim shared area(30)  as section
dim shared uu(19), vv(19), dt(9)
t& = 2050
areapointer = 0: g_areav = 0

voic = 1
dim shared vlight(19, 9) as long
dim shared p(0 to 2000) as pt                   '3d vector points
dim shared pz(0 to 2000) as long
dim shared quad(0 to 2000, 0 to 9) as integer      '3d flat surfaces3

dim shared vlightd(1, 2000) as long
'DIM SHARED NUMQUAD, nump, Texture$, index, objindex
dim shared Texture(2100*2), compass(1800*1)
'DIM SHARED eyex AS LONG, eyey AS LONG, eyez AS LONG
'DIM SHARED angle, yaw
dim shared rotp_x(0 to 2000)
dim shared rotp_y(0 to 2000)
dim shared rotp_yn(0 to 2000)
'DIM SHARED ZBUF AS INTEGER
dim buf(0 to 700) as buff
'DIM SHARED last$
'DIM SHARED ccount
'DIM SHARED do_zbuf
dim shared fco(-360 to 720) as single
dim shared fsi(-360 to 720) as single
dim shared anim(5000) as pt, animp(500)

dim shared FPS as integer
dim fps_count as integer
dim shared timer_next as long


dim shared obj(20) as object

for i = -360 to 720
  fco(i) = cos(i * 3.141593 / 180)
  fsi(i) = sin(i * 3.141593 / 180)
next i
do_zbuf = -1

NUMQUAD = 0: nump = 0: index = 0: objindex = 0

tsize = 64
'//Load from file
'c$ = UCASE$(COMMAND$)
'IF INSTR(c$, "/NT") THEN NT = 1: PRINT "_NT mode" ELSE NT = 0

if command$ = "" then i$ = "cave" else i$ = command$

print "_Init Objects"
color 7

load_objects
'PRINT " |-Numquad"; NUMQUAD
'PRINT " |-Nump"; nump
color 15
print "_Init Events";

load_events 1
print "_Init Game Fields"

fields = load_field(i$)
'FOR ct = 0 TO fields
'PRINT area(ct)_n; area(ct)_s; area(ct)_e; area(ct)_w
'NEXT
'COLOR 7: PRINT " |-Fields"; fields; fields = fields - 1
'COLOR 7: PRINT " |-areav"; areapointer; pdatapointer
color 15

print "_Init Available Memory: "; fre(-1)
print

color 15': print "Press any key to start..."
'for EQ = 1 to 60: i$ = inkey$: next
'i$ = input$(1)
i$ = ""

' ==================///----MAIN PROGRAM----\\\======================

DQBinitVGA
DQBsetFrameRate 35
DQBsetTextureSize tsize
bp$ = "ham.pal"
g = DQBloadImage(1, 0, 0, bp$, palt, 320, 200)
'loadimage 1, "ham.raw", 0, 0
DQBget 1, 0, 128, 40, 171, VARSEG(compass(0)), varptr(compass(0))
c = 0
dim shared Font(1000)
for e = 0 to (8 * 8) step 8
  'DQBget 1, 0, 192, 7, 199, VARSEG(font(0)), VARPTR(font(0))
  'DQBget 1, 8, 192, 15, 199, VARSEG(font(36)), VARPTR(font(36))
  'DQBget 1, 16, 192, 23, 199, VARSEG(font(72)), VARPTR(font(72))
  DQBget 1, e, 192, e + 7, 199, VARSEG(Font(c * 36)), varptr(Font(c * 36))
  c = c + 1
next


'FOR y = 0 TO 199: FOR x = 0 TO 319
'IF DQBpoint(1, x, y) = 0 THEN DQBpset 1, x, y, 255
'NEXT x, y

dim shared VsEG(20) as long
DQBsetPal(palt)

dim shared g_c1(0 to 255), g_c2(0 to 255), g_c3(0 to 255)
for c = 0 to 255
  out &H3C7, c
  g_c1(c) = inp(&H3C9)
  g_c2(c) = inp(&H3C9)
  g_c3(c) = inp(&H3C9)
next c

dim nc(255, 9) as integer
d1 = 0: d2 = 0: d3 = 0
dim shared ic
colorize ic, d1, d2, d3
'DQBgetCol i, r, g, b
'DQBsetCol 0, r, g, b
for z = 0 to 9
  for e = 0 to 255
    DQBgetCol e, r, g, B
    s1 = d1 - r
    s2 = d2 - g
    s3 = d3 - B
    s1 = cint(s1 * (10 - (z + 1)) / 10)
    s2 = cint(s2 * (10 - (z + 1)) / 10)
    s3 = cint(s3 * (10 - (z + 1)) / 10)
    c1 = r + s1
    c2 = g + s2
    c3 = B + s3
    colorize nc(e, z), c1, c2, c3
    'nc2(E, z) = DQBfindCol(c1, c2, c3)
  next
next
colorize white, 63, 63, 10

erase g_c1, g_c2, g_c3
for e = 0 to 19
  for z = 0 to 9
    vlight(e, z) = 41000l * e
    vlight(e, z) = vlight(e, z) + 4100l * z
  next z
next e
'DQBsetSolidPut

for e = 0 to 4        
  DQBget 1, e * tsize, 0, (e + 1) * tsize - 1, tsize - 1, VARSEG(Texture(2100)), varptr(Texture(2100))
  VsEG(e) = VARSEG(Texture(0))
  'DQBpoke VARSEG(Texture(0)), VARPTR(Texture(0)), vlight(e, z), 4100
  
  for z = 9 to 0 step -1
    DQBput 1, 64 * e, 0, VARSEG(Texture(2100)), varptr(Texture(2100))
    for y = 0 to 63
      for x = 64 * e to 64 * (e + 1) - 1
        ze = DQBpoint(1, x, y)
        ze = nc(ze, z)': IF ze = 0 THEN ze = 255
        DQBpset 1, x, y, ze
      next x
    next y
      
    DQBget 1, e * tsize, 0, (e + 1) * tsize - 1, tsize - 1, VARSEG(Texture(0)), varptr(Texture(0))
    'DQBpoke VARSEG(texture(0)), VARPTR(texture(0)), vlight(e, z), 4100
    d = move2xms(4100, VARSEG(Texture(0)), varptr(Texture(0)), handle1, vlight(e, z))
    
  next z
next e

e = 4
for ee = 0 to 4
  e = e + 1
  DQBget 1, ee * tsize, 64, (ee + 1) * tsize - 1, 127, VARSEG(Texture(2100)), varptr(Texture(2100))
  VsEG(e) = VARSEG(Texture(0))
  'DQBpoke VARSEG(Texture(0)), VARPTR(Texture(0)), vlight(e, z), 4100
  
  for z = 9 to 0 step -1
    DQBput 1, 64 * ee, 63, VARSEG(Texture(2100)), varptr(Texture(2100))
    for y = 64 to 127
      for x = 64 * ee to 64 * (ee + 1) - 1
        ze = DQBpoint(1, x, y)
        ze = nc(ze, z)': IF ze = 255 THEN ze = 0
        DQBpset 1, x, y, ze
      next x
    next y        
    DQBget 1, ee * tsize, 64, (ee + 1) * tsize - 1, 127, VARSEG(Texture(0)), varptr(Texture(0))
    'DQBpoke VARSEG(texture(0)), VARPTR(texture(0)), vlight(e, z), 4100
    d = move2xms(4100, VARSEG(Texture(0)), varptr(Texture(0)), handle1, vlight(e, z))
    
  next z  
  
  
next ee
    
for ee = 0 to 4
  e = e + 1
  DQBget 1, ee * tsize, 128, (ee + 1) * tsize - 1, 191, VARSEG(Texture(2100)), varptr(Texture(2100))
  VsEG(e) = VARSEG(Texture(0))
  'DQBpoke VARSEG(Texture(0)), VARPTR(Texture(0)), vlight(e, z), 4100
  
  for z = 9 to 0 step -1
    DQBput 1, 64 * ee, 63, VARSEG(Texture(2100)), varptr(Texture(2100))
    for y = 128 to 191
      for x = 64 * ee to 64 * (ee + 1) - 1
        ze = DQBpoint(1, x, y)
        ze = nc(ze, z)': IF ze = 255 THEN ze = 0
        DQBpset 1, x, y, ze
      next x
    next y            
    DQBget 1, ee * tsize, 128, (ee + 1) * tsize - 1, 191, VARSEG(Texture(0)), varptr(Texture(0))
    'DQBpoke VARSEG(texture(0)), VARPTR(texture(0)), vlight(e, z), 4100
    d = move2xms(4100, VARSEG(Texture(0)), varptr(Texture(0)), handle1, vlight(e, z))
    
    #macro Dump
      if z=9 then
        put(0,0),@Texture(0),pset    
        DbgPrint(e & " " & ee & " " & z)
        flip : __sleep 500
      end if
    #endmacro
    
  next z
next ee
        
Angle = 0: yaw = 0

'DQBclearLayer 2:  g = DQBloadLayer(2, bp$, palt)
'MID$(palt, 766, 3) = CHR$(58) + CHR$(58) + CHR$(58)
'MID$(palt, 757, 3) = CHR$(3) + CHR$(3) + CHR$(28)
'MID$(palt, 763, 3) = CHR$(20) + CHR$(30) + CHR$(8)
'MID$(palt, 760, 3) = CHR$(63) + CHR$(62) + CHR$(7)


'DEF SEG = 0
'n& = 1600                 'Reprogram the timer to 30hz
'LB& = n& AND &HFF           'instead of 18.2 (for 30 frames
'HB& = (n& / 256) AND &HFF   'per second.)
'OUT &H43, &H3C:
'DQBwait 1
'OUT &H40, INT(LB&)
'DQBwait 1
'OUT &H40, INT(HB&)

DQBinstallKeyboard

if mouse then
  DQBresetMouse
  DQBsetMouseRange 0, 0, 10000, 160
  DQBsetMousePos 5000 + obj(player1).Angle, 80': IF NT = 1 THEN dqbwait 1
end if

mouse_action = 0

'dqbsetframerate 35
'Efire(enemy) c
'Efire(eNemy2) = 50

'consol_execute "exec modem.cfg"
lc = 100: lights = 1300
if no_sound = 0 then music_init
dt(0) = 0: dt(1) = 1: dt(2) = 0: dt(3) = 2
yaw = 55: numfdis = 3'PEEK(1132): POKE 1132, 0
DQBsetFontTexture VARSEG(Font(0)), varptr(Font(0))
do
  music_check
  
  
  'lights = lights + lc: IF lights > 5000 OR lights < 4000 THEN lc = -lc
  'lights = 500: IF INT(RND * 40) = 22 THEN lights = 5500
  if DQBkey(&H42) then savel
  '//Update FPS
  fps_count = fps_count + 1
  if (timer * 100) >= timer_next then FPS = fps_count: fps_count = 0: timer_next = (timer * 100) + 100
  if mouse then
    obj(player1).Angle = (5000 - DQBmouseX) mod 360'obj(player1).angle - (DQBmouseX - 200) / 3
    if DQBmouseX > 7000 then DQBsetMousePos DQBmouseX - 360, DQBmouseY else if DQBmouseX < 3000 then DQBsetMousePos DQBmouseX + 360, DQBmouseY
  end if
  dda:
  if obj(player1).Angle < 0 then obj(player1).Angle = obj(player1).Angle + 360
  if obj(player1).Angle < 0 then goto dda
  
  
  
  if DQBkey(KEYUP) then dis = dis - 1 else if DQBkey(KEYDOWN) then dis = dis + 1 else if dis > 0 then dis = dis - 1 else if dis < 0 then dis = dis + 1
  
  if dis > 5 then dis = 5 else if dis < -5 then dis = -5
  if dis <> 0 then thrust_obj player1, dis * numfdis
  
  if DQBkey(KEYLEFT) then
    obj(player1).Angle = (obj(player1).Angle + 4) mod 360
    if mouse then DQBsetMousePos 5000 - obj(player1).Angle, 0
  else
    if DQBkey(KEYRIGHT) then
      obj(player1).Angle = obj(player1).Angle - 4: if obj(player1).Angle < 0 then obj(player1).Angle = obj(player1).Angle + 360
      if mouse then DQBsetMousePos 5000 - obj(player1).Angle, 0
    end if
  end if
  
  
  'objdis2 = dis2 - 1 ELSE IF DQBkey(KEYLEFT) THEN dis2 = dis2 + 1 ELSE IF dis2 > 0 THEN dis2 = dis2 - 1 ELSE IF dis2 < 0 THEN dis2 = dis2 + 1
  'IF dis2 > 5 THEN dis2 = 5 ELSE IF dis2 < -5 THEN dis2 = -5
  '   IF dis2 <> 0 THEN straf_obj player1, dis2 * numfdis
  
  
  'IF DQBkey(&H49) THEN eyeyy = eyeyy + 50: dis = 1 ELSE IF DQBkey(&H51) THEN eyeyy = eyeyy - 50: dis = 1
  'IF DQBkey(&H33) THEN dist = dist + 50: dis = 1 ELSE IF DQBkey(&H34) THEN dist = dist - 50: dis = 1
  
  'eyeyy = -1950
  '//Update Frame independent timer
  numf& = timer * 100&
  
  '//Check if player entered "new" area
  
  cHECKFIELD player1, 70, 0
  checky player1
  
  'eyex = obj(player1).x
  'eyez = obj(player1).z
  
  
  'find_distance  player1, 600, 0, eyex, eyez
  '2100
  find_distance player1, -dist, 0, eyex, eyez
  'obj(0).x = eyex: obj(0).z = eyez: obj(0).area = obj(player1).area
  'cHECKFIELD 0, 1000, 0
  'eyex = obj(0).x: eyez = obj(0).z
  
  
  'Angle = 360 - obj(player1).Angle
  
  
  'ccount = (ccount + 16) MOD 360
  backeye = obj(player1).y
  'IF dis <> 0 OR dis2 <> 0 THEN ccount = (ccount + (numfdis * 2)) MOD 360
  eyey = obj(player1).y + 1400 + eyeyy
  
  
  'eyex = 0: eyez = 0: eyey = 6000
  'IF NOT DQBmouseRB THEN
  'dx& = (eyex - obj(player1).x) * (eyex - obj(player1).x)
  'dx& = dx& + (eyez - obj(player1).z) * (eyez - obj(player1).z)
  'dx& = SQR(dx&)
  'dy& = (eyey - (obj(player1).y + 400))
  'yaw = ((DQBangle(0, 0, dx&, dy&)) / 255 * 360 + 250) MOD 360
  Angle = 180 - obj(player1).Angle' (180 - (DQBangle(eyex, eyez, obj(player1).x, obj(player1).z)) / 255 * 360) MOD 360
  'END IF
  'IF yaw < dyaw THEN yaw = yaw + 1 ELSE IF yaw > dyaw THEN yaw = yaw - 1
  'IF angle < dangle THEN angle = angle + 1 ELSE IF angle > dangle THEN angle = angle - 1
  'obj(player1).y = obj(player1).y + INT(40 * fco(ccount))
  
  music_check
  'tt2 = tt2 + 1: IF tt2 = 2 THEN tt2 = 0:
  vv(11) = (vv(11) + 1) mod 64
  'tt3 = tt3 + 1: IF tt3 = 20 THEN tt3 = 0: uu(11) = (uu(11) + 1) MOD 64
  tt = tt + 1: if tt = 3 then tt = 0
  'IF tt = 0 THEN t2 = (t2 + 1) MOD 4: obj(3).anim = dt(t2)
  if dis <> 0 then
    if tt = 0 then t = (t + 1) mod 4: obj(player1).anim = dt(t)
  else
    obj(player1).anim = 0
  end if
  update 0
  
  check_events
  
  
  
  obj(player1).y = backeye
  'obj(player1).yaw = dis
  
  '//Fire rocket
  
  '    IF DQBmouseLB AND fire < 1 THEN fire = 200: fire_rocket player1, nr
  
  
  'IF fire > 0 THEN fire = fire - numfdis
  
  'FOR e = 0 TO 20
  'IF obj(rocket(e)).flag = 0 THEN
  '  
  '     cHECKFIELD rocket(e), 100, DUMMY
  '     IF DUMMY = 1 THEN blow e, nf
  '    
  '    '//Check if rocket hit an bot object (player 2)
  '            IF ABS(obj(rocket(e)).z - obj(bot).z) < 300 THEN
  '             IF ABS(obj(rocket(e)).x - obj(bot).x) < 300 THEN blow e, nf: obj(enemy).rock = 40 + INT(RND * 15) + 1: GOTO RSKP
  '            END IF
  '
  '    '        IF ABS(obj(rocket(e)).z - obj(eNemy2).z) < 250 THEN
  '    '         IF ABS(obj(rocket(e)).x - obj(eNemy2).x) < 250 THEN blow e, nf: : obj(eNemy2).rock = 40 + INT(RND * 15) + 1: GOTO RSKP
  '    '        END IF
  '          
  '            IF ABS(obj(rocket(e)).z - obj(player1).z) < 300 THEN
  '             IF ABS(obj(rocket(e)).x - obj(player1).x) < 300 THEN blow e, nf: : obj(player1).rock = 40 + INT(RND * 15) + 1
  '             END IF
  '   
  '            thrust.obj rocket(e), 20 * numfdis
  'RSKP':
  '        obj(rocket(e)).life = obj(rocket(e)).life - 1
  '        IF obj(rocket(e)).life = 0 THEN obj(rocket(e)).flag = 1
  '  
  '       
  '  
  '    END IF
  '    NEXT
  '     
  'FOR e = 0 TO 5
  'IF obj(fire(e)).flag = 0 THEN
  '    obj(fire(e)).Angle = cct
  '    obj(fire(e)).life = obj(fire(e)).life - 1: IF obj(fire(e)).life = 0 THEN obj(fire(e)).flag = 1
  'END IF
  'NEXT
  cct = cct + 20: if cct > 360 then cct = 0
  
  
  if DQBkey(&H1) then qut = 1
  if qut = 1 then
    'DQBMOUSEhide
    
    
    if DQBkey(&H15) then qut = 2
    if DQBkey(&H31) then qut = 0
  end if
  'update 1
  'END IF
  
loop until qut = 2
close
' n& = 65535                      'Program the timer back to
' LB& = n& AND &HFF               '18.2hz before exiting!
' HB& = (n& / 256) AND &HFF
' OUT &H43, &H3C: OUT &H40, LB&: OUT &H40, HB&
'
' OUT &H61, INP(&H61) OR &H82: OUT &H20, &H20

d = XmsdeAlloc(handle1)
DQBremoveKeyboard
if mouse then DQBresetMouse
DQBinitText
DQBclose
'DUMMY& = SETMEM(17000)
'DUMMY& = SETMEM(66000)
screen 0
width 80, 25
cls
'clear
color 14, 13: locate 1, 1: a$ = "HAM-3d Engine beta v" + version$
locate 1, 1: print space$(80): locate 1, 40 - (len(a$) / 2): print a$
color 7, 0
print
a$ = "Written in Quick Basic 4.5 and DQB w/XMS by Eric Carr": locate 3, 40 - (len(a$) / 2): print a$
a$ = "This beta and all files contained with it are copyright(c) 2000 by ECG\ ": locate 5, 40 - (len(a$) / 2): print a$
color 14
a$ = "Email: call_me_sometime@hotmail.com": : locate 7, 40 - (len(a$) / 2): print a$
a$ = "Website: http://spinball.webjump.com": : locate 8, 40 - (len(a$) / 2): print a$
print ""
print
color 15
print
print "Thanks for beta testing this!"
print
DEE:

system


e:
DbgPrint( "Err: " & Err & " Erl: " & ERL )
'OPEN "error.log" FOR APPEND AS #99: PRINT #99, ERR, ERL: CLOSE #99
resume next

sub cHECKFIELD (o, l, DUMMY) static
  DUMMY = 0
  sxn = obj(o).x - l: sxp = obj(o).x + l
  szn = obj(o).z - l: szp = obj(o).z + l
  if sxp <= area(obj(o).area).e then
    if sxn >= area(obj(o).area).w then
      if szp <= area(obj(o).area).n then
        if szn >= area(obj(o).area).s then exit sub
      end if
    end if
  end if
  
  for e = 0 to fields
    if obj(o).x <= area(e).e and obj(o).x >= area(e).w and obj(o).z <= area(e).n and obj(o).z >= area(e).s and obj(o).area <> e then obj(o).area = e: exit sub
    'IF ABS(AREA(OBJ(o).AREA).low - AREA(e).low) < 200 THEN OBJ(o).AREA = e: EXIT SUB
  next
  
  'IF szp > area(obj(o).area).n OR szn < area(obj(o).area).s OR sxp > area(obj(o).area).e OR sxn < area(obj(o).area).w THEN
  
  if szn <= area(obj(o).area).s then
    for e = 0 to fields
      if (szn <= area(e).n and szn >= area(e).s) then
        if sxn >= area(e).w then
          if sxp <= area(e).e then
            if obj(o).area <> e then exit sub
          end if
        end if
      end if
    next
  end if
  
  if szp >= area(obj(o).area).n then
    for e = 0 to fields
      if (szp >= area(e).s and szp <= area(e).n) then
        if sxn >= area(e).w then
          if sxp <= area(e).e then
            if obj(o).area <> e then exit sub
          end if
        end if
      end if
    next
  end if
  
  if sxn <= area(obj(o).area).w then
    for e = 0 to fields
      if (sxn <= area(e).e and sxn >= area(e).w) then
        if szn >= area(e).s then
          if szp <= area(e).n then
            if obj(o).area <> e then exit sub
          end if
        end if
      end if
    next
  end if
  
  if sxp >= area(obj(o).area).e then
    for e = 0 to fields
      if (sxp >= area(e).w and sxp <= area(e).e) then
        if szn >= area(e).s then
          if szp <= area(e).n then
            if obj(o).area <> e then exit sub
          end if
        end if
      end if
    next
  end if
  
  
  
  DUMMY = 1
  
  
  if sxp > area(obj(o).area).e then
    obj(o).x = area(obj(o).area).e - l: cHECKFIELD o, l, ee
  else
    if sxn < area(obj(o).area).w then
      obj(o).x = area(obj(o).area).w + l: cHECKFIELD o, l, ee
    end if
  end if
  
  
  if szp > area(obj(o).area).n then
    obj(o).z = area(obj(o).area).n - l': CHECKFIELD o, l, ee
  else
    if szn < area(obj(o).area).s then
      obj(o).z = area(obj(o).area).s + l': CHECKFIELD o, l, ee
    end if
  end if
  
end sub

REM $static
sub checky (e) static
  
  select case area(obj(e).area).slant
  
  case 0
    obj(e).y = area(obj(e).area).low
  case 1
    obj(e).y = ((obj(e).z - area(obj(e).area).s) / (area(obj(e).area).n - area(obj(e).area).s)) * area(obj(e).area).high
    obj(e).y = obj(e).y + area(obj(e).area).low
  case 2
    obj(e).y = ((obj(e).x - area(obj(e).area).w) / (area(obj(e).area).e - area(obj(e).area).w)) * area(obj(e).area).high
    obj(e).y = obj(e).y + area(obj(e).area).low
  case 3
    obj(e).y = ((area(obj(e).area).n - obj(e).z) / (area(obj(e).area).n - area(obj(e).area).s)) * area(obj(e).area).high
    obj(e).y = obj(e).y + area(obj(e).area).low
  case 4
    obj(e).y = ((area(obj(e).area).e - obj(e).x) / (area(obj(e).area).e - area(obj(e).area).w)) * area(obj(e).area).high
    obj(e).y = obj(e).y + area(obj(e).area).low
    
    
  end select
end sub

sub dq (e) static
  x1 = rotp_x(quad(e, 0)): y1 = rotp_y(quad(e, 0))
  x2 = rotp_x(quad(e, 1)): y2 = rotp_y(quad(e, 1))
  x3 = rotp_x(quad(e, 2)): y3 = rotp_y(quad(e, 2))
  
  if x1 < 0 and x2 < 0 and x3 < 0 then exit sub
  if y1 < 0 and y2 < 0 and y3 < 0 then exit sub
  if x1 > 319 and x2 > 319 and x3 > 319 then exit sub
  if y1 > 199 and y2 > 199 and y3 > 199 then exit sub
  t& = x1 - x2
  t& = t& * (y3 - y2)
  t1& = y1 - y2
  t1& = t1& * (x3 - x2)
  if (t& - t1&) >= 0 then exit sub
  
  ZBUF = ZBUF + 1: buf(ZBUF).SEL = e
  t1& = pz(quad(e, 0))
  't1& = t1& + pz(quad(e, 1))
  't1& = t1& + pz(quad(e, 2))
  if pz(quad(e, 1)) > t1& then t1& = pz(quad(e, 1))
  if pz(quad(e, 2)) > t1& then t1& = pz(quad(e, 2))
  buf(ZBUF).z = t1&
  buf(ZBUF).d = 0
  
  'IF l THEN EXIT SUB
  exit sub
  buf(ZBUF).d = vlightd(0, e) - obj(player1).x + obj(o).x
  buf(ZBUF).d = buf(ZBUF).d * buf(ZBUF).d
  d& = vlightd(1, e) - obj(player1).z + obj(o).z
  d& = d& * d&
  buf(ZBUF).d = sqr(d& + buf(ZBUF).d)
  d& = p(quad(e, 0)).y - obj(player1).y + obj(o).y
  d& = d& * d&
  buf(ZBUF).d = buf(ZBUF).d * buf(ZBUF).d
  buf(ZBUF).d = sqr(d& + buf(ZBUF).d)
  
  exit sub
  
  
  
  
end sub

sub drawquad (e, c, l) static
  if rotp_yn(quad(e, 0)) = 0 then exit sub
  if rotp_yn(quad(e, 1)) = 0 then exit sub
  if rotp_yn(quad(e, 2)) = 0 then exit sub
  
  x1 = rotp_x(quad(e, 0)): y1 = rotp_y(quad(e, 0))
  x2 = rotp_x(quad(e, 1)): y2 = rotp_y(quad(e, 1))
  x3 = rotp_x(quad(e, 2)): y3 = rotp_y(quad(e, 2))
  
  if x1 < 0 and x2 < 0 and x3 < 0 then exit sub
  if y1 < 0 and y2 < 0 and y3 < 0 then exit sub
  if x1 > 319 and x2 > 319 and x3 > 319 then exit sub
  if y1 > 199 and y2 > 199 and y3 > 199 then exit sub
  if c = 1 then
    t& = x1 - x2
    t& = t& * (y3 - y2)
    t1& = y1 - y2
    t1& = t1& * (x3 - x2)
    if (t& - t1&) >= 0 then exit sub
  end if
  
  ZBUF = ZBUF + 1: buf(ZBUF).SEL = e
  t1& = pz(quad(e, 0))
  't1& = t1& + pz(quad(e, 1))
  't1& = t1& + pz(quad(e, 2))
  if pz(quad(e, 1)) > t1& then t1& = pz(quad(e, 1))
  if pz(quad(e, 2)) > t1& then t1& = pz(quad(e, 2))
  buf(ZBUF).z = t1&
  buf(ZBUF).d = 0
  
  'IF l THEN EXIT SUB
  exit sub
  buf(ZBUF).d = vlightd(0, e) - obj(player1).x + obj(o).x
  buf(ZBUF).d = buf(ZBUF).d * buf(ZBUF).d
  d& = vlightd(1, e) - obj(player1).z + obj(o).z
  d& = d& * d&
  buf(ZBUF).d = sqr(d& + buf(ZBUF).d)
  d& = p(quad(e, 0)).y - obj(player1).y + obj(o).y
  d& = d& * d&
  buf(ZBUF).d = buf(ZBUF).d * buf(ZBUF).d
  buf(ZBUF).d = sqr(d& + buf(ZBUF).d)
  
  exit sub
  
  
  
  
end sub

function f3d (e, x1&, y1&, z1&, xn, yn) static
  
  
  'ny1& = CLNG((y1&) * fco(obj(tempo).yaw) + (nz1&) * fsi(obj(tempo).yaw))
  'nz1& = CLNG(-(y1&) * fsi(obj(tempo).yaw) + (nz1&) * fco(obj(tempo).yaw))
  
  ny1& = ((y1&) * fco(obj(tempo).yaw) + (z1&) * fsi(obj(tempo).yaw))
  nz1& = (-(y1&) * fsi(obj(tempo).yaw) + (z1&) * fco(obj(tempo).yaw))
  
  nx1& = ((x1&) * fco(obj(tempo).Angle) - (nz1&) * fsi(obj(tempo).Angle))
  nz1& = ((x1&) * fsi(obj(tempo).Angle) + (nz1&) * fco(obj(tempo).Angle))
  
  
  x10& = nx1& + obj(tempo).x
  y10& = ny1& + obj(tempo).y
  z10& = nz1& + obj(tempo).z
  
  nx1& = ((x10& - eyex)  * fco(Angle) - (z10& - eyez) * fsi(Angle) + eyex)
  nz1& = ((x10& - eyex)  * fsi(Angle) + (z10& - eyez) * fco(Angle) + eyez)
  ny1& = ((y10& - eyey)  * fco(yaw)   + (nz1& - eyez) * fsi(yaw) + eyey)
  nz1& = (-(y10& - eyey) * fsi(yaw)   + (nz1& - eyez) * fco(yaw) + eyez)
  
  nx1& = nx1& - eyex': nx(e) = nx1&
  ny1& = ny1& - eyey': ny(e) = ny1&
  nz1& = nz1& - eyez': nz(e) = nz1&
  
  if nz1& < 0 then f3d = 0: exit function
  if abs(nz1&) > 20000 or abs(nx1&) > 20000 then f3d = 1: pz(e) = 20000: goto skipf
  
  pz(e) = (nz1& * nz1&) + (ny1& * ny1&)
  pz(e) = pz(e) + (nx1& * nx1&)
  pz(e) = sqr(pz(e))
  'IF pz(e) > 4500 THEN f3d = 0: EXIT FUNCTION
  
  'pz(e) = NZ1&
  't& = (nx1& / nx1&) * 256
  't& = 256
  skipf:
  if nz1& = 0 then nz1& = 1
  xn& = 160 + (nx1& / (nz1&)) * 256
  yn& = 100 + (-ny1& / (nz1&)) * 256
  if xn& > 10024 then xn& = 10024 else if xn& < -10024 then xn& = -10024
  if yn& > 10024 then yn& = 10024 else if yn& < -10024 then yn& = -10024
  xn = xn&: yn = yn&
  f3d = 1
  
end function

function fd (e, x1&, y1&, z1&, xn, yn) static
  
  
  'ny1& = CLNG((y1&) * fco(obj(tempo).yaw) + (nz1&) * fsi(obj(tempo).yaw))
  'nz1& = CLNG(-(y1&) * fsi(obj(tempo).yaw) + (nz1&) * fco(obj(tempo).yaw))
  
  ny1& = ((y1&) * fco(obj(1).yaw) + (z1&) * fsi(obj(1).yaw))
  nz1& = (-(y1&) * fsi(obj(1).yaw) + (z1&) * fco(obj(1).yaw))
  
  nx1& = ((x1&) * fco(obj(1).Angle) - (nz1&) * fsi(obj(1).Angle))
  nz1& = ((x1&) * fsi(obj(1).Angle) + (nz1&) * fco(obj(1).Angle))
  
  
  x10& = nx1& + obj(1).x
  y10& = ny1& + obj(1).y
  z10& = nz1& + obj(1).z
  
  nx1& = ((x10& - eyex) * fco(Angle) - (z10& - eyez) * fsi(Angle) + eyex)
  nz1& = ((x10& - eyex) * fsi(Angle) + (z10& - eyez) * fco(Angle) + eyez)
  ny1& = ((y10& - eyey) * fco(yaw) + (nz1& - eyez) * fsi(yaw) + eyey)
  nz1& = (-(y10& - eyey) * fsi(yaw) + (nz1& - eyez) * fco(yaw) + eyez)
  
  nz1& = nz1& - eyez': nz(e) = nz1&
  
  if nz1& < 0 then fd = 0: exit function
  
  nx1& = nx1& - eyex': nx(e) = nx1&
  ny1& = ny1& - eyey': ny(e) = ny1&
  
  
  pz(e) = (nz1& * nz1&) + (ny1& * ny1&)
  pz(e) = pz(e) + (nx1& * nx1&)
  pz(e) = sqr(pz(e))
  if nz1& = 0 then nz1& = 1
  xn& = 160 + (nx1& / (nz1&)) * 256
  yn& = 100 + (-ny1& / (nz1&)) * 256
  if xn& > 10024 then xn& = 10024 else if xn& < -10024 then xn& = -10024
  if yn& > 10024 then yn& = 10024 else if yn& < -10024 then yn& = -10024
  xn = xn&: yn = yn&
  fd = 1
  
end function

REM $dynamic
sub music_check
  if DQBinUse(1) or no_sound = 1 then exit sub
  DQBplaySound music_n2, 1, 11025, ONCE
  if DQBloadRawSound(music_n1, music_file, music_counter, 64000) = 3 then
    music_counter = 0: d = DQBloadRawSound(music_n1, music_file, music_counter, 64000)
  end if
  music_counter = music_counter + 64000
  swap music_n1, music_n2
end sub

sub music_init
  if DQBloadRawSound(music_n1, music_file, music_counter, 64000) then DQBclose: print DQBerror$: end
  DQBplaySound music_n1, 1, 11025, ONCE
  music_counter = music_counter + 64000
  if DQBloadRawSound(music_n2, music_file, music_counter, 64000) then DQBclose: print DQBerror$: end
  music_counter = music_counter + 64000
end sub

REM $static
sub thrust_obj (o, dis)
  obj(o).x = obj(o).x + cint((-dis) * fco(270 + obj(o).Angle))
  obj(o).z = obj(o).z + cint((-dis) * fsi(270 + obj(o).Angle))
end sub

'
sub update (M) static
  
  'DQBclearLayer bb
  'DQBcopylayer 1,bb
  'DQBboxf bb, 0, 0, 319, 199, 0
  ZBUF = 0
  lx = obj(2).x - 2600: rx = obj(2).x + 2600: uz = obj(2).z + 2600
  dz = obj(2).z - 2600
  for e = 1 to obj(1).nump
    ee = obj(1).indexp + e
    if p(ee).x > lx then
      if p(ee).x < rx then
        if p(ee).z > dz then
          if p(ee).z < uz then
            rotp_yn(ee) = fd(ee, p(ee).x, p(ee).y, p(ee).z, rotp_x(ee), rotp_y(ee)): goto ne
          end if
        end if
      end if
    end if
    rotp_yn(ee) = 0
    ne:
  next
  
  for e = 1 to obj(1).NUMQUAD
    if rotp_yn(quad(e, 0)) = 1 then
      if rotp_yn(quad(e, 1)) = 1 then
        if rotp_yn(quad(e, 2)) = 1 then dq e
      end if
    end if
  next
  'FOR e = 0 TO pdatap(obj(player1).area, 0) - 1
  'ee = pdata(pdatap(obj(player1).area, 1) + E)
  'rotp_yn(ee) = f3d(ee, P(ee).x, P(ee).y, P(ee).z, rotp_x(ee), rotp_y(ee))
  'NEXT
  
  'FOR E = 0 TO areav(obj(player1).area, 0) - 1: drawquad areavp(areav(obj(player1).area, 1) + E), 1, 0: NEXT
  
  for tempo = 2 to objindex
    if obj(tempo).flag = 0 then
      if obj(tempo).anim = 0 then
        for e = 1 to obj(tempo).nump
          ee = obj(tempo).indexp + e
          rotp_yn(ee) = f3d(ee, p(ee).x, p(ee).y, p(ee).z, rotp_x(ee), rotp_y(ee))
        next e
        for e = 1 to obj(tempo).NUMQUAD
          drawquad obj(tempo).index + e, obj(tempo).bfc, obj(tempo).light
        next e
        else
          for e = 1 to obj(tempo).nump
            ee = obj(tempo).indexp + e
            te = animp(obj(tempo).anim + obj(tempo).animpointer) + e - 1
            rotp_yn(ee) = f3d(ee, anim(te).x, anim(te).y, anim(te).z, rotp_x(ee), rotp_y(ee))
          next e
          for e = 1 to obj(tempo).NUMQUAD
            drawquad obj(tempo).index + e, obj(tempo).bfc, obj(tempo).light
          next e
        end if
      end if        
    next tempo
      
  qsort 1, ZBUF
  dedum = -1
  for ee = ZBUF to 1 step -1
    e = buf(ee).SEL
    
    if buf(ee).d > lights then
      j& = buf(ee).d - lights
      if j& > lights then j& = lights
      j& = lights - j&
      flik = (j& / lights) * 10
      if flik > 0 then
        flik = flik - 1
        'DQBpeek VARSEG(Texture(0)), VARPTR(Texture(0)), vlight(quad(e, 3), flik), 4100
        d = movefromxms(4100, handle1, vlight(quad(e, 3), flik), VARSEG(Texture(0)), varptr(Texture(0)))
        
        DQBttri bb, rotp_x(quad(e, 0)), rotp_y(quad(e, 0)), rotp_x(quad(e, 1)), rotp_y(quad(e, 1)), rotp_x(quad(e, 2)), rotp_y(quad(e, 2)), quad(e, 4) + uu(quad(e, 3)), quad(e, 5) + vv(quad(e, 3)), quad(e, 6) + uu(quad(e, 3)), quad(e, 7) + vv(quad(e, 3)),  _
        quad(e, 8) + uu(quad(e, 3)), quad(e, 9) + vv(quad(e, 3)), VsEG(0), varptr(Texture(0))
        'ELSE
        'DQBtri bb, rotp_x(quad(e, 0)), rotp_y(quad(e, 0)), rotp_x(quad(e, 1)), rotp_y(quad(e, 1)), rotp_x(quad(e, 2)), rotp_y(quad(e, 2)), 0
        
      end if
      
    else
      'DQBpeek VARSEG(texture(0)), VARPTR(texture(0)), vlight(quad(e, 3), 9), 4100
      d = movefromxms(4100, handle1, vlight(quad(e, 3), 9), VARSEG(Texture(0)), varptr(Texture(0)))
      
      'DQBttri bb, rotp_x(quad(e, 0)), rotp_y(quad(e, 0)), rotp_x(quad(e, 1)), rotp_y(quad(e, 1)), rotp_x(quad(e, 2)), rotp_y(quad(e, 2)), quad(e, 4), quad(e, 5), quad(e, 6), quad(e, 7), quad(e, 8), quad(e, 9), VsEG(0), VARPTR(Texture(0))
      DQBttri bb, rotp_x(quad(e, 0)), rotp_y(quad(e, 0)), rotp_x(quad(e, 1)), rotp_y(quad(e, 1)), rotp_x(quad(e, 2)), rotp_y(quad(e, 2)), quad(e, 4) + uu(quad(e, 3)), quad(e, 5) + vv(quad(e, 3)), quad(e, 6) + uu(quad(e, 3)), quad(e, 7) + vv(quad(e, 3 _
      )), quad(e, 8) + uu(quad(e, 3)), quad(e, 9) + vv(quad(e, 3)), VsEG(0), varptr(Texture(0))
      
      
    end if
  next
  
  'IF CONSOL_POS > -96 THEN consol_show CONSOL_POS
  
  prnt "FPS:" + str$(FPS), 230, 180, 2
  'DQBprint bb, "FPS " + STR$(FPS), 230, 180, white
  
  'DQBprint bb, "yaw " + STR$(yaw), 230, 190, white
  'DQBprint bb, "", numfdis, 0, 255
  ' dx& = (eyex - obj(player1).x) * (eyex - obj(player1).x)
  ' dx& = dx& + (eyez - obj(player1).z) * (eyez - obj(player1).z)
  ' dx& = SQR(dx&)
  ' dy& = eyey - obj(player1).y + 400
  'DQBprint bb, STR$(FPS), 0, 20, 255
  'DQBprint bb, STR$(yaw) + STR$(eyeyy) + STR$(dist)+str$(angle), 0, 20, 254
  'DQBprint bb, STR$(obj(player1).x) + STR$(obj(player1).z) + STR$(obj(player1).area), 0, 30, white
  'DQBprint bb, STR$(NUMQUAD) + STR$(nump) + STR$(index), 0, 40, 255
  'IF INSTR(consol.history(0), "]") THEN talk = 0 ELSE talk = 1
  'IF consol_countdown > 0 OR talk = 0 THEN consol_countdown = consol_countdown - 1: consol_print bb, 0, 0, consol_history(talk)
  
  'IF DQBframeReady THEN DQBcopyLayer 1, 0
  if qut = 1 then prnt "Quit this engine test? [Y/N]:", 20, 100, 2
  '       DQBprint bb, "Quit this test [Y/N]", 40, 100, 255
  DQBrPut bb, 278, 0, VARSEG(compass(0)), varptr(compass(0)), ((obj(player1).Angle + 180) mod 360) / 360 * 256, 100
  '//**** CHECK EVENTS BEFORE DRAWING TO SCREEN****\\
  
end sub

