#lang "qb"

declare sub prnt (a$, x%, y%, c%)
declare sub setex (e%)
declare sub load_world (a$, n%)
declare sub load_events (n%)
declare function exist% (a$)
declare sub music_check ()
declare sub checky (e%)
declare sub cHECKFIELD (o%, l%, DUMMY%)
declare sub update (M%)

'$INCLUDE: 'DIRECTQB.BI'
'$INCLUDE: 'common.bi'

declare sub load_objects ()

declare function load_field% (a$)
declare sub play3d (n%, o%)
declare function load_object% (a$)
declare sub find_distance (o%, dis%, r%, rx&, rz&)
declare sub thrust_obj (o%, dis%)
declare function f3d% (e%, x1&, y1&, z1&, xn%, yn%)

defint A-Z
sub check_events
  
  for e = 1 to eventtop(obj(player1).area)
    if abs(event(obj(player1).area, e).x - obj(player1).x) <= event(obj(player1).area, e).w then
      if abs(event(obj(player1).area, e).z - obj(player1).z) <= event(obj(player1).area, e).w then
        select case event(obj(player1).area, e).class
        case 1
          prnt rtrim$(event(obj(player1).area, e).command), 1, 1, 1
          
        case 2
          prnt "The sign says:", 1, 1, 1
          prnt rtrim$(event(obj(player1).area, e).command), 1, 10, 2
          
        case 3
          for dis = 0 to 63
            DQBfadeStepTo 50, 50, 50
            music_check
            DQBwait 1
          next
          'OPEN "debug.txt" FOR APPEND AS #dbg: PRINT #dbg, "before"
          a$ = mid$(event(obj(player1).area, e).command, 1, 12)
          a$ = rtrim$(a$)
          l = asc(mid$(event(obj(player1).area, e).command, 20, 1))
          load_world a$, l
          if mouse then DQBsetMousePos 5000 - obj(player1).Angle, 0
          Angle = 180 - obj(player1).Angle
          cHECKFIELD player1, 90, 0
          checky player1
          find_distance player1, -500, 0, eyex, eyez
          eyey = obj(player1).y + 1400
          dis = 0: dis2 = 0
          update 0
          
          
          DQBcopyLayer bb, 0
          for dis = 0 to 63
            DQBfadeStepIn palt
            music_check
            DQBwait 1
          next
          dis = 0
          exit sub
        end select
      end if
    end if
  next
  'if DQBkey(&H21) then DQBcopyLayer bb, 0: exit sub
  music_check
  while DQBframeReady = 0: music_check: DQBwait 1: wend  
  '__sleep(1)
  DQBcopyLayer bb, 0
  
end sub

function exist (a$)
  if lcase$(DQBdir$(a$, 0)) = lcase$(a$) then exist = 1 else exist = 0
end function

sub find_distance (o, dis, r, rx&, rz&) static
  rx& = obj(o).x + clng((dis) * fco(270 + r + obj(o).Angle))
  rz& = obj(o).z + clng((dis) * fsi(270 + r + obj(o).Angle))  
end sub

dim shared rocket(99)
sub fire_rocket (o, nr) static
  obj(rocket(nr)).flag = 0
  obj(rocket(nr)).life = 120
  find_distance o, -380, 0, obj(rocket(nr)).x, obj(rocket(nr)).z
  obj(rocket(nr)).Angle = obj(o).Angle
  obj(rocket(nr)).y = obj(o).y + 500
  play3d 1, rocket(nr)
  thrust_obj rocket(nr), 100
  nr = nr + 1: if nr > 20 then nr = 0  
end sub

sub load_events (n)
  'OPEN "debug.txt" FOR APPEND AS #dbg: PRINT #dbg, "N is"; n: CLOSE #dbg
  for e = 0 to ubound(eventtop): eventtop(e) = 0: next
  f = freefile()
  open i$ + ".eve" for input as #f
  input #f, a
  for e = 1 to a
    input #f, ax, az, aa
    if e = n then obj(player1).x = ax: obj(player1).z = az: obj(player1).Angle = aa
  next
  
  input #f, a$
  color 7
  while not eof(f)
    input #f, a, x, z, w, c, t$
    if c = 4 then
      input #f, e$
      e = load_object(t$)
      obj(e).x = x
      obj(e).z = z
      obj(e).y = w
      obj(e).Angle = a
      obj(e).kind = e$
    else
      eventtop(a) = eventtop(a) + 1
      event(a, eventtop(a)).x = x
      event(a, eventtop(a)).z = z
      event(a, eventtop(a)).w = w
      event(a, eventtop(a)).class = c
      event(a, eventtop(a)).command = t$
      if c = 3 then input #f, n: mid$(event(a, eventtop(a)).command, 20, 1) = chr$(n)' OPEN "debug.txt" FOR APPEND AS #dbg: PRINT #dbg, n: CLOSE #dbg
    end if
    
    'PRINT ".";
  wend
  color 15
  print ""
  close #f
      
end sub

function load_field (a$)
  f = freefile()
  open a$ + ".FLD" for input as #f
  input #f, nf
  for ct = 0 to nf - 1
    input #f, area(ct).w, area(ct).n, area(ct).e, area(ct).s
    input #f, area(ct).slant, area(ct).low, area(ct).high
  next
  load_field = nf
  if eof(f) then close #f: exit function
  e = ct
  
  for ct = 0 to nf - 1
    areav(ct, 1) = areapointer
    input #f, areav(ct, 0)
    
    for ctt = 1 to areav(ct, 0)
      input #f, areavp(areapointer)
      areapointer = areapointer + 1
    next
  next
  pdatapointer = 0
  for ct = 0 to nf - 1
    pdatap(ct, 1) = pdatapointer
    pct = 0
    for ctt = 0 to areav(ct, 0) - 1
      for z = 0 to 2
        e = quad(areavp(areav(ct, 1) + ctt), z)
        for tc = pdatap(ct, 1) to pdatapointer
          if pdata(tc) = e then goto skipme
        next
        pdata(pdatapointer) = e: pdatapointer = pdatapointer + 1
        skipme:
      next z
    next ctt
    pdatap(ct, 0) = pdatapointer - pdatap(ct, 1) + 1
  next ct
  close #f
end function

function load_object (a$)
  'DQBboxf 0, 0, 0, 319, 199, 1
  numn = nump
  'IF last$ <> a$ THEN PRINT " -added model [" + a$ + "]": last$ = a$
  fil$ = a$ + ".T3D"
  
  f = freefile()
  open fil$ for input as #f
  input #f, Texture$
  
  objindex = objindex + 1: o = objindex: load_object = o
  
  input #f, obj(o).nump
  'PRINT obj(o).nump; " :";
  
  obj(o).indexp = numn
  
  for e = 1 to obj(o).nump
    nump = nump + 1
    input #f, p(nump).x, p(nump).y, p(nump).z
    'IF INT(SQR(p(nump).x * p(nump).x + p(nump).z * p(nump).z)) > obj(o).wide THEN obj(o).wide = INT(SQR(p(nump).x * p(nump).x + p(nump).z * p(nump).z))
  next
  input #f, obj(o).NUMQUAD
  'PRINT obj(o).numquad
  
  obj(o).index = NUMQUAD
  
  for e = 1 to obj(o).NUMQUAD
    NUMQUAD = NUMQUAD + 1
    for ee = 0 to 9
      input #f, quad(NUMQUAD, ee): if ee < 3 then quad(NUMQUAD, ee) = quad(NUMQUAD, ee) + numn
    next
  next
  obj(o).bfc = 1
  close #f
  
  if exist(a$ + ".a3d") then    
    open a$ + ".a3d" for binary as #f
    dim b as string * 1
    get #f, , b: Frames = asc(b)
    get #f, , b: np = asc(b)
    obj(o).animpointer = animpointer
    
    for t = 1 to np
      get #f, , anim(con)
    next
    for e = 1 to Frames
      animp(e + animpointer) = con
      for t = 1 to np
        get #f, , anim(con)
        con = con + 1
      next
    next
    animpointer = animpointer + Frames
    close #f
  end if  
  
end function

sub load_objects
  NUMQUAD = 0: nump = 0: index = 0: objindex = 0
  level = load_object(i$)': obj(level).y = 600
  player1 = load_object("cube")
  obj(player1).light = 1
  obj(player1).x = 0
  
  'FOR e = 0 TO 20
  'rocket(e) = load_object("nail")
  'obj(rocket(e)).flag = 1
  'obj(rocket(e)).light = 1
  'NEXT e
  
  'FOR e = 0 TO 5
  'fire(e) = load_object("fire")
  'obj(fire(e)).x = INT(RND * 20000) - 10000
  'obj(fire(e)).z = INT(RND * 20000) - 8000
  'obj(fire(e)).y = 0
  'obj(fire(e)).flag = 1
  'obj(fire(e)).light = 1
  'NEXT e
  
  'COLOR 15
  'PRINT "_Total objects: "; objindex
  'PRINT "_Total FACES: "; NUMQUAD
  'PRINT "_Total POINTS: "; nump
  for e = 0 to NUMQUAD
    vlightd(0, e) = (p(quad(e, 0)).x + p(quad(e, 1)).x + p(quad(e, 2)).x) / 3
    vlightd(1, e) = (p(quad(e, 0)).z + p(quad(e, 1)).z + p(quad(e, 2)).z) / 3
  next
  modem_stat = 0: init_stat = 0
  number$ = ""
  
  'init_string$ = "ATZ"
  'Port = 4: IRQ = 0: rate = 19200
  
end sub

sub load_world (a$, n)
  NUMQUAD = 0: nump = 0: index = 0: objindex = 0
  areapointer = 0: g_areav = 0: animpointer = 0: con = 0
  i$ = a$
  'OPEN "debug.txt" FOR APPEND AS #dbg: PRINT #dbg, "b4 objects"; n: CLOSE #dbg
  load_objects
  'OPEN "debug.txt" FOR APPEND AS #dbg: PRINT #dbg, "b4 events"; n: CLOSE #dbg
  load_events (n)
  'OPEN "debug.txt" FOR APPEND AS #dbg: PRINT #dbg, "b4 field"; n: CLOSE #dbg
  fields = load_field(a$)
end sub

REM $dynamic
sub play3d (n, o) static
  exit sub
  if abs(obj(o).x - eyex) > 30000 or abs(obj(o).z - eyez) > 30000 then exit sub
  v& = sqr((obj(o).x - eyex) * (obj(o).x - eyex) + (obj(o).z - eyez) * (obj(o).z - eyez))
  if v& >= 20000 then exit sub
  l = int((v& / 20000) * 50)
  l = 50 - l
  
  DQBsetVoiceVol voic, l
  DQBplaySound n, voic, 11025, ONCE
  voic = voic + 1: if voic > 3 then voic = 1
end sub

REM $static
sub prnt (a$, x, y, c)
  DQBsetFontTexture VARSEG(font(0)), varptr(font(0))
  DQBprints bb, a$, x + 1, y + 1, white, 36
  DQBsetFontTexture VARSEG(font(36 * c)), varptr(font(36 * c))
  DQBprints bb, a$, x, y, white, 36
end sub

REM $dynamic
sub qsort (LFT, RGHT)
  dim s as long
  if (LFT < RGHT) then
    s = buf(RGHT).z
    i = LFT
    j = RGHT - 1
    do
      cont:
      while (buf(i).z < s): i = i + 1: wend
      while (j >= 1 and s < buf(j).z): j = j - 1: wend
      if (i < j) then
        swap buf(i).SEL, buf(j).SEL
        swap buf(i).z, buf(j).z
        swap buf(i).d, buf(j).d
        i = i + 1
        j = j - 1
        goto cont
      end if
    loop while (i < j)
    swap buf(i).SEL, buf(RGHT).SEL
    swap buf(i).z, buf(RGHT).z
    swap buf(i).d, buf(RGHT).d
    qsort LFT, i - 1
    qsort i + 1, RGHT
  end if

end sub

